<template>
  <div class="table-responsive">
    <table class="table">
      <thead>
        <tr>
          <th scope="col">Nombre</th>
          <th scope="col">Otros Nombres</th>
          <th scope="col">Primer Apellido</th>
          <th scope="col">Segndo Apellido</th>
          <th scope="col">Tipo doc</th>
          <th scope="col">Num doc</th>
          <th scope="col">Email</th>
          <th scope="col">Pais</th>
          <th scope="col">Área</th>
          <th scope="col">Estado</th>
        </tr>
      </thead>
      <tbody>
        <tr style="cursor: pointer" scope="col" v-for="(user, index) in displayedUsers" :key="index" @click="$router.push(`/user/${user._id}`)">
          <td>{{ user.fistName }}</td>
          <td>{{ user.otherName }}</td>
          <td>{{ user.firstSurname }}</td>
          <td>{{ user.secondSurname }}</td>
          <td>{{ user.idType }}</td>
          <td>{{ user.idNumber }}</td>
          <td>{{ user.email }}</td>
          <td>{{ user.country }}</td>
          <td>{{ user.area }}</td>
          <td>{{ user.state }}</td>
        </tr>
      </tbody>
    </table>
    
  </div>
  <div class="row" >

  
  <div class="btn-group col-md-2 offset-md-5">
        <button
          type="button"
          class="btn btn-sm btn-outline-secondary"
          v-if="page != 1"
          @click="page--"
        >-</button>
        <button
          type="button"
          class="btn btn-sm btn-outline-secondary"
        >{{page}} de {{Math.ceil(users.length / 10)}}</button>
        <button
          type="button"
          @click="page++"
          v-if="page < Math.ceil(users.length / 10)"
          class="btn btn-sm btn-outline-secondary"
        >+</button>
        
      </div>
    </div>
</template>
  
<script lang="ts">
  import { User } from "@/interfaces/user";
  import { getTasks } from "@/services/userServices";
  import { defineComponent } from "vue";
  export default defineComponent({
    name: "tasks-list",
    data() {
      return {
        users: [] as User[],
        page: 1,
        perPage: 10,
        pages: [] as number[]
      };
    },
    methods: {
      async loadTasks() {
        try {
          const res = await getTasks();
          this.users = res.data;
        } catch (error) {
          console.error(error);
        }
      },
      
      setUsers() {
        let numberOfPages = Math.ceil(this.users.length / this.perPage);
        for (let i = 1; i <= numberOfPages; i++) {
          
          this.pages.push(i);
        }
      },
      paginate(users: any):User[] {
        let page = this.page;
        let perPage = this.perPage;
        let from = (page * perPage) - perPage;
        let to = (page * perPage);
        return users.slice(from, to);
      },
      
    },


    created() {
    this.loadTasks();
    },

    mounted() {
      this.loadTasks();
    },

  
    watch: {
      users(){
        this.setUsers();
      }
    },

    computed: {
      displayedUsers: function ():User[] {
        return this.paginate(this.users);
      }
    }
  });

  </script>